//////////////////// Includes /////////////////////////////////////////////////

#include "stdafx.h"
#include "DemoGUI.h"
#include "..\8055N++.h"


//////////////////// Macros / Defines /////////////////////////////////////////

#ifdef _DEBUG
#define new DEBUG_NEW
#endif //#ifdef _DEBUG

#pragma warning(suppress: 26426)
CDemoGUIApp theApp;


#define USE_C8055NCLIENTDEVICE2 //Uncomment to use the C8055NClientDevice2 class

#ifdef USE_C8055NCLIENTDEVICE2
HID::C8055NClientDevice2 g_ClientDevice; //Use the C8055NClientDevice2 class which calls directly into the C8055NDevice class
#else
HID::C8055NClientDevice g_ClientDevice; //Use the C8055NClientDevice class which implements the K8055N.DLL wrapper
#endif //#ifdef USE_C8055NClientDevice2

////////////////////////// Implementation /////////////////////////////////////

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CDemoGUIApp, CWinAppEx) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()

#pragma warning(suppress: 26455)
CDemoGUIApp::CDemoGUIApp()
{
  SetAppID(_T("Naughter.DemoGUI.1.0"));
}

BOOL CDemoGUIApp::InitInstance()
{
  //Initialize common control
  INITCOMMONCONTROLSEX InitCtrls;
  InitCtrls.dwSize = sizeof(InitCtrls);
  InitCtrls.dwICC = ICC_WIN95_CLASSES;
  if (!InitCommonControlsEx(&InitCtrls)) //NOLINT(clang-analyzer-core.CallAndMessage)
    return FALSE;

  //Let the base class do its thing
  if (!__super::InitInstance())
    return FALSE;

  //Show the main dialog
  CMainDlg dlg;
  m_pMainWnd = &dlg;
  dlg.DoModal();

  return FALSE;
}


#pragma warning(suppress: 26455)
CMainDlg::CMainDlg() : CDialog{CMainDlg::IDD},
                       m_nCounter1Value{0},
                       m_nCounter2Value{0},
                       m_nCycleDigitalChannel{1},
                       m_nTimer1{0},
                       m_nTimer2{0},
                       m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CMainDlg, CDialog) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
  ON_BN_CLICKED(IDC_CONNECT, &CMainDlg::OnClickedConnect)
  ON_BN_CLICKED(IDC_DLL_VERSION, &CMainDlg::OnClickedDllVersion)
  ON_WM_TIMER()
  ON_WM_DESTROY()
  ON_BN_CLICKED(IDC_SET_ALL_DIGITAL, &CMainDlg::OnClickedSetAllDigital)
  ON_BN_CLICKED(IDC_SET_ALL_ANALOG, &CMainDlg::OnClickedSetAllAnalog)
  ON_BN_CLICKED(IDC_CLEAR_ALL_ANALOG, &CMainDlg::OnClickedClearAllAnalog)
  ON_BN_CLICKED(IDC_CLEAR_ALL_DIGITAL, &CMainDlg::OnClickedClearAllDigital)
  ON_BN_CLICKED(IDC_RESET_COUNTER1, &CMainDlg::OnClickedResetCounter1)
  ON_BN_CLICKED(IDC_RESET_COUNTER2, &CMainDlg::OnClickedResetCounter2)
  ON_BN_CLICKED(IDC_COUNTER1_DEBOUNCE1, &CMainDlg::OnBnClickedCounter1Debounce1)
  ON_BN_CLICKED(IDC_COUNTER1_DEBOUNCE2, &CMainDlg::OnBnClickedCounter1Debounce2)
  ON_BN_CLICKED(IDC_COUNTER1_DEBOUNCE3, &CMainDlg::OnBnClickedCounter1Debounce3)
  ON_BN_CLICKED(IDC_COUNTER1_DEBOUNCE4, &CMainDlg::OnBnClickedCounter1Debounce4)
  ON_BN_CLICKED(IDC_COUNTER2_DEBOUNCE1, &CMainDlg::OnBnClickedCounter2Debounce1)
  ON_BN_CLICKED(IDC_COUNTER2_DEBOUNCE2, &CMainDlg::OnBnClickedCounter2Debounce2)
  ON_BN_CLICKED(IDC_COUNTER2_DEBOUNCE3, &CMainDlg::OnBnClickedCounter2Debounce3)
  ON_BN_CLICKED(IDC_COUNTER2_DEBOUNCE4, &CMainDlg::OnBnClickedCounter2Debounce4)
  ON_BN_CLICKED(IDC_OUTPUT1, &CMainDlg::OnBnClickedOutput1)
  ON_BN_CLICKED(IDC_OUTPUT2, &CMainDlg::OnBnClickedOutput2)
  ON_BN_CLICKED(IDC_OUTPUT3, &CMainDlg::OnBnClickedOutput3)
  ON_BN_CLICKED(IDC_OUTPUT4, &CMainDlg::OnBnClickedOutput4)
  ON_BN_CLICKED(IDC_OUTPUT5, &CMainDlg::OnBnClickedOutput5)
  ON_BN_CLICKED(IDC_OUTPUT6, &CMainDlg::OnBnClickedOutput6)
  ON_BN_CLICKED(IDC_OUTPUT7, &CMainDlg::OnBnClickedOutput7)
  ON_BN_CLICKED(IDC_OUTPUT8, &CMainDlg::OnBnClickedOutput8)
  ON_BN_CLICKED(IDC_SEARCH_DEVICES, &CMainDlg::OnClickedSearchDevices)
  ON_BN_CLICKED(IDC_DEVICE0, &CMainDlg::OnBnClickedDevice0)
  ON_BN_CLICKED(IDC_DEVICE1, &CMainDlg::OnBnClickedDevice1)
  ON_BN_CLICKED(IDC_DEVICE2, &CMainDlg::OnBnClickedDevice2)
  ON_BN_CLICKED(IDC_DEVICE3, &CMainDlg::OnBnClickedDevice3)
  ON_BN_CLICKED(IDC_READBACK, &CMainDlg::OnClickedReadback)
  ON_BN_CLICKED(IDC_OUTPUT_TEST, &CMainDlg::OnClickedOutputTest)
  ON_BN_CLICKED(IDC_DISCONNECT, &CMainDlg::OnClickedDisconnect)
  ON_WM_VSCROLL()
  ON_BN_CLICKED(IDC_TEST_PWM, &CMainDlg::OnClickedTestPwm)
END_MESSAGE_MAP()

void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
  DDX_Control(pDX, IDC_AD1, m_wndAD1);
  DDX_Control(pDX, IDC_AD1_VALUE, m_wndAD1Value);
  DDX_Control(pDX, IDC_AD2, m_wndAD2);
  DDX_Control(pDX, IDC_AD2_VALUE, m_wndAD2Value);
  DDX_Control(pDX, IDC_DA1, m_wndDA1);
  DDX_Control(pDX, IDC_DA1_VALUE, m_wndDA1Value);
  DDX_Control(pDX, IDC_DA2, m_wndDA2);
  DDX_Control(pDX, IDC_DA2_VALUE, m_wndDA2Value);
  DDX_Control(pDX, IDC_DLL_VERSION_VALUE, m_wndDLLVersionValue);
  DDX_Control(pDX, IDC_SK5, m_wndSK5);
  DDX_Control(pDX, IDC_SK6, m_wndSK6);
  DDX_Control(pDX, IDC_OUTPUT1, m_wndOutput1);
  DDX_Control(pDX, IDC_OUTPUT2, m_wndOutput2);
  DDX_Control(pDX, IDC_OUTPUT3, m_wndOutput3);
  DDX_Control(pDX, IDC_OUTPUT4, m_wndOutput4);
  DDX_Control(pDX, IDC_OUTPUT5, m_wndOutput5);
  DDX_Control(pDX, IDC_OUTPUT6, m_wndOutput6);
  DDX_Control(pDX, IDC_OUTPUT7, m_wndOutput7);
  DDX_Control(pDX, IDC_OUTPUT8, m_wndOutput8);
  DDX_Control(pDX, IDC_CONNECT_RESULTS, m_wndConnectResults);
  DDX_Control(pDX, IDC_COUNTER1_VALUE, m_wndCounter1Value);
  DDX_Text(pDX, IDC_COUNTER1_VALUE, m_nCounter1Value);
  DDX_Control(pDX, IDC_COUNTER2_VALUE, m_wndCounter2Value);
  DDX_Text(pDX, IDC_COUNTER2_VALUE, m_nCounter2Value);
  DDX_Control(pDX, IDC_INPUT1, m_wndInput1);
  DDX_Control(pDX, IDC_INPUT2, m_wndInput2);
  DDX_Control(pDX, IDC_INPUT3, m_wndInput3);
  DDX_Control(pDX, IDC_INPUT4, m_wndInput4);
  DDX_Control(pDX, IDC_INPUT5, m_wndInput5);
  DDX_Control(pDX, IDC_DEVICE0, m_wndDevice0);
  DDX_Control(pDX, IDC_DEVICE1, m_wndDevice1);
  DDX_Control(pDX, IDC_DEVICE2, m_wndDevice2);
  DDX_Control(pDX, IDC_DEVICE3, m_wndDevice3);
  DDX_Control(pDX, IDC_OUTPUT_TEST, m_wndOutputTest);
  DDX_Control(pDX, IDC_READBACK, m_wndReadback);
  DDX_Control(pDX, IDC_RESET_COUNTER1, m_wndResetCounter1);
  DDX_Control(pDX, IDC_RESET_COUNTER2, m_wndResetCounter2);
  DDX_Control(pDX, IDC_COUNTER1_DEBOUNCE1, m_wndCounter1Debounce1);
  DDX_Control(pDX, IDC_COUNTER1_DEBOUNCE2, m_wndCounter1Debounce2);
  DDX_Control(pDX, IDC_COUNTER1_DEBOUNCE3, m_wndCounter1Debounce3);
  DDX_Control(pDX, IDC_COUNTER1_DEBOUNCE4, m_wndCounter1Debounce4);
  DDX_Control(pDX, IDC_COUNTER2_DEBOUNCE1, m_wndCounter2Debounce1);
  DDX_Control(pDX, IDC_COUNTER2_DEBOUNCE2, m_wndCounter2Debounce2);
  DDX_Control(pDX, IDC_COUNTER2_DEBOUNCE3, m_wndCounter2Debounce3);
  DDX_Control(pDX, IDC_COUNTER2_DEBOUNCE4, m_wndCounter2Debounce4);
  DDX_Control(pDX, IDC_CONNECT, m_wndConnect);
  DDX_Control(pDX, IDC_DISCONNECT, m_wndDisconnect);
  DDX_Control(pDX, IDC_SET_ALL_DIGITAL, m_wndSetAllDigital);
  DDX_Control(pDX, IDC_CLEAR_ALL_DIGITAL, m_wndClearAllDigital);
  DDX_Control(pDX, IDC_SET_ALL_ANALOG, m_wndSetAllAnalog);
  DDX_Control(pDX, IDC_CLEAR_ALL_ANALOG, m_wndClearAllAnalog);
  DDX_Control(pDX, IDC_TEST_PWM, m_wndTestPWM);
}

BOOL CMainDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);
  m_wndSK5.SetCheck(1);
  m_wndSK6.SetCheck(1);
  m_wndDA1.SetRange(0, 255);
  m_wndDA1.SetPos(255);
  m_wndDA1.SetTicFreq(20);
  m_wndDA2.SetRange(0, 255);
  m_wndDA2.SetPos(255);
  m_wndDA2.SetTicFreq(20);
  m_wndAD1.SetRange(0, 255);
  m_wndAD1.SetPos(0);
  SetWindowTheme(m_wndAD1.GetSafeHwnd(), L"", L"");
  m_wndAD2.SetRange(0, 255);
  m_wndAD2.SetPos(0);
  SetWindowTheme(m_wndAD2.GetSafeHwnd(), L"", L"");
  m_wndCounter1Value.SetWindowText(_T(""));
  m_wndCounter2Value.SetWindowText(_T(""));

  return TRUE;
}

void CMainDlg::OnClickedConnect()
{
  int nCardNumber = 3;
  if (m_wndSK5.GetCheck())
    nCardNumber -= 1;
  if (m_wndSK6.GetCheck())
    nCardNumber -= 2;
  const int h = g_ClientDevice.OpenDevice(nCardNumber);
  switch (h)
  {
    default:
    {
      CString sResults;
      sResults.Format(_T("Card %d connected"), h);
      m_wndConnectResults.SetWindowText(sResults);

      //Create Timer1
      if (m_nTimer1)
        KillTimer(m_nTimer1);
      m_nTimer1 = SetTimer(1, 50, nullptr);

      //Enable the various UI elements when a connection is open
      EnableControlsWhenDeviceIsOpen(TRUE);

      //Set the default debounce times
      m_wndCounter1Debounce2.SetCheck(1);
      g_ClientDevice.SetCounterDebounceTime(1, 2);
      m_wndCounter2Debounce2.SetCheck(1);
      g_ClientDevice.SetCounterDebounceTime(2, 2);

      break;
    }
    case -1:
    {
      CString sResults;
      sResults.Format(_T("Card %d not found"), nCardNumber);
      m_wndConnectResults.SetWindowText(sResults);
      break;
    }
  }
}

void CMainDlg::OnClickedDllVersion()
{
#ifdef USE_C8055NCLIENTDEVICE2
  CString sVersion(_T("Not using K8055D.DLL"));
#else
  const int nVersion = g_ClientDevice.Version();
  CString sVersion;
  sVersion.Format(_T("%d.%d.%d.%d"), nVersion >> 24, (nVersion >> 16) & 0xFF, (nVersion >> 8) & 0xFF, nVersion & 0xFF);
#endif //#ifdef USE_C8055NCLIENTDEVICE2
  m_wndDLLVersionValue.SetWindowText(sVersion);
}

void CMainDlg::OnTimer(UINT_PTR nIDEvent)
{
  //Let the base class do its thing
  __super::OnTimer(nIDEvent);

  if (nIDEvent == m_nTimer1)
  {
    int nData1{};
    int nData2{};
    g_ClientDevice.ReadAllAnalog(&nData1, &nData2);
    //nData1 = g_ClientDevice.ReadAnalogChannel(1);
    //nData2 = g_ClientDevice.ReadAnalogChannel(2);
    m_wndAD1.SetPos(nData1);
    m_wndAD2.SetPos(nData2);
    CString sValue;
    sValue.Format(_T("% 3d"), nData1);
    m_wndAD1Value.SetWindowText(sValue);
    sValue.Format(_T("% 3d"), nData2);
    m_wndAD2Value.SetWindowText(sValue);
    sValue.Format(_T("%d"), g_ClientDevice.ReadCounter(1));
    const int nCounter1 = g_ClientDevice.ReadCounter16(1);
    UNREFERENCED_PARAMETER(nCounter1);
    m_wndCounter1Value.SetWindowText(sValue);
    sValue.Format(_T("%d"), g_ClientDevice.ReadCounter(2));
    const int nCounter2 = g_ClientDevice.ReadCounter16(2);
    UNREFERENCED_PARAMETER(nCounter2);
    m_wndCounter2Value.SetWindowText(sValue);
    const int i{g_ClientDevice.ReadAllDigital()};
    m_wndInput1.SetCheck(i & 0x01);
    m_wndInput2.SetCheck(i & 0x02);
    m_wndInput3.SetCheck(i & 0x04);
    m_wndInput4.SetCheck(i & 0x08);
    m_wndInput5.SetCheck(i & 0x010);
    /*
    m_wndInput1.SetCheck(g_ClientDevice.ReadDigitalChannel(1));
    m_wndInput2.SetCheck(g_ClientDevice.ReadDigitalChannel(2));
    m_wndInput3.SetCheck(g_ClientDevice.ReadDigitalChannel(3));
    m_wndInput4.SetCheck(g_ClientDevice.ReadDigitalChannel(4));
    m_wndInput5.SetCheck(g_ClientDevice.ReadDigitalChannel(5));
    */
#ifdef _DEBUG
    const bool bConnected = g_ClientDevice.Connected();
    UNREFERENCED_PARAMETER(bConnected);
    const int nCardVersion = g_ClientDevice.CardVersion();
    UNREFERENCED_PARAMETER(nCardVersion);
    //std::array<BYTE, 8> rxBuffer{};
    //g_ClientDevice.ReadAll(rxBuffer.data());
    //g_ClientDevice.WriteAllDigital(rand() % 256);
    //g_ClientDevice.OutputAllAnalog(rand() % 256, rand() % 256);
#endif //#ifdef _DEBUG
  }
  else if (nIDEvent == m_nTimer2)
  {
    g_ClientDevice.ClearDigitalChannel(m_nCycleDigitalChannel);
    switch (m_nCycleDigitalChannel)
    {
      case 1:
      {
        m_wndOutput1.SetCheck(0);
        break;
      }
      case 2:
      {
        m_wndOutput2.SetCheck(0);
        break;
      }
      case 3:
      {
        m_wndOutput3.SetCheck(0);
        break;
      }
      case 4:
      {
        m_wndOutput4.SetCheck(0);
        break;
      }
      case 5:
      {
        m_wndOutput5.SetCheck(0);
        break;
      }
      case 6:
      {
        m_wndOutput6.SetCheck(0);
        break;
      }
      case 7:
      {
        m_wndOutput7.SetCheck(0);
        break;
      }
      case 8:
      {
        m_wndOutput8.SetCheck(0);
        break;
      }
      default:
      {
        ASSERT(FALSE);
        break;
      }
    }
    m_nCycleDigitalChannel++;
    if (m_nCycleDigitalChannel == 9)
      m_nCycleDigitalChannel = 1;
    g_ClientDevice.SetDigitalChannel(m_nCycleDigitalChannel);
    switch (m_nCycleDigitalChannel)
    {
      case 1:
      {
        m_wndOutput1.SetCheck(1);
        break;
      }
      case 2:
      {
        m_wndOutput2.SetCheck(1);
        break;
      }
      case 3:
      {
        m_wndOutput3.SetCheck(1);
        break;
      }
      case 4:
      {
        m_wndOutput4.SetCheck(1);
        break;
      }
      case 5:
      {
        m_wndOutput5.SetCheck(1);
        break;
      }
      case 6:
      {
        m_wndOutput6.SetCheck(1);
        break;
      }
      case 7:
      {
        m_wndOutput7.SetCheck(1);
        break;
      }
      case 8:
      {
        m_wndOutput8.SetCheck(1);
        break;
      }
      default:
      {
        ASSERT(FALSE);
        break;
      }
    }
  }
}

void CMainDlg::OnDestroy()
{
  if (m_nTimer1)
  {
    KillTimer(m_nTimer1);
    m_nTimer1 = 0;
  }
  if (m_nTimer2)
  {
    KillTimer(m_nTimer2);
    m_nTimer2 = 0;
  }
  g_ClientDevice.CloseDevice();
  __super::OnDestroy();
}

void CMainDlg::OnClickedSetAllDigital()
{
  g_ClientDevice.SetAllDigital();
  m_wndOutput1.SetCheck(1);
  m_wndOutput2.SetCheck(1);
  m_wndOutput3.SetCheck(1);
  m_wndOutput4.SetCheck(1);
  m_wndOutput5.SetCheck(1);
  m_wndOutput6.SetCheck(1);
  m_wndOutput7.SetCheck(1);
  m_wndOutput8.SetCheck(1);
}

void CMainDlg::OnClickedSetAllAnalog()
{
  g_ClientDevice.SetAllAnalog();
  g_ClientDevice.SetAnalogChannel(0);
  g_ClientDevice.SetAnalogChannel(1);
  g_ClientDevice.SetAnalogChannel(2);
  g_ClientDevice.SetAnalogChannel(9);
  m_wndDA1.SetPos(0);
  m_wndDA2.SetPos(0);
  CString sValue;
  sValue.Format(_T("% 3d"), 255);
  m_wndDA1Value.SetWindowText(sValue);
  m_wndDA2Value.SetWindowText(sValue);
}

void CMainDlg::OnClickedClearAllAnalog()
{
  g_ClientDevice.ClearAllAnalog();
  g_ClientDevice.ClearAnalogChannel(0);
  g_ClientDevice.ClearAnalogChannel(1);
  g_ClientDevice.ClearAnalogChannel(2);
  g_ClientDevice.ClearAnalogChannel(9);
  m_wndDA1.SetPos(255);
  m_wndDA2.SetPos(255);
  CString sValue;
  sValue.Format(_T("% 3d"), 0);
  m_wndDA1Value.SetWindowText(sValue);
  m_wndDA2Value.SetWindowText(sValue);
}

void CMainDlg::OnClickedClearAllDigital()
{
  g_ClientDevice.ClearAllDigital();
  m_wndOutput1.SetCheck(0);
  m_wndOutput2.SetCheck(0);
  m_wndOutput3.SetCheck(0);
  m_wndOutput4.SetCheck(0);
  m_wndOutput5.SetCheck(0);
  m_wndOutput6.SetCheck(0);
  m_wndOutput7.SetCheck(0);
  m_wndOutput8.SetCheck(0);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnClickedResetCounter1()
{
  g_ClientDevice.ResetCounter(1);
  CString sValue;
  sValue.Format(_T("%d"), g_ClientDevice.ReadCounter(1));
  m_wndCounter1Value.SetWindowText(sValue);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnClickedResetCounter2()
{
  g_ClientDevice.ResetCounter(2);
  CString sValue;
  sValue.Format(_T("%d"), g_ClientDevice.ReadCounter(2));
  m_wndCounter2Value.SetWindowText(sValue);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter1Debounce1()
{
  g_ClientDevice.SetCounterDebounceTime(1, 0);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter1Debounce2()
{
  g_ClientDevice.SetCounterDebounceTime(1, 2);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter1Debounce3()
{
  g_ClientDevice.SetCounterDebounceTime(1, 10);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter1Debounce4()
{
  g_ClientDevice.SetCounterDebounceTime(1, 1000);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter2Debounce1()
{
  g_ClientDevice.SetCounterDebounceTime(2, 0);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter2Debounce2()
{
  g_ClientDevice.SetCounterDebounceTime(2, 2);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter2Debounce3()
{
  g_ClientDevice.SetCounterDebounceTime(2, 10);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnBnClickedCounter2Debounce4()
{
  g_ClientDevice.SetCounterDebounceTime(2, 1000);
}

void CMainDlg::OnBnClickedOutput1()
{
  if (m_wndOutput1.GetCheck())
    g_ClientDevice.SetDigitalChannel(1);
  else
    g_ClientDevice.ClearDigitalChannel(1);
}

void CMainDlg::OnBnClickedOutput2()
{
  if (m_wndOutput2.GetCheck())
    g_ClientDevice.SetDigitalChannel(2);
  else
    g_ClientDevice.ClearDigitalChannel(2);
}

void CMainDlg::OnBnClickedOutput3()
{
  if (m_wndOutput3.GetCheck())
    g_ClientDevice.SetDigitalChannel(3);
  else
    g_ClientDevice.ClearDigitalChannel(3);
}

void CMainDlg::OnBnClickedOutput4()
{
  if (m_wndOutput4.GetCheck())
    g_ClientDevice.SetDigitalChannel(4);
  else
    g_ClientDevice.ClearDigitalChannel(4);
}

void CMainDlg::OnBnClickedOutput5()
{
  if (m_wndOutput5.GetCheck())
    g_ClientDevice.SetDigitalChannel(5);
  else
    g_ClientDevice.ClearDigitalChannel(5);
}

void CMainDlg::OnBnClickedOutput6()
{
  if (m_wndOutput6.GetCheck())
    g_ClientDevice.SetDigitalChannel(6);
  else
    g_ClientDevice.ClearDigitalChannel(6);
}

void CMainDlg::OnBnClickedOutput7()
{
  if (m_wndOutput7.GetCheck())
    g_ClientDevice.SetDigitalChannel(7);
  else
    g_ClientDevice.ClearDigitalChannel(7);
}

void CMainDlg::OnBnClickedOutput8()
{
  if (m_wndOutput8.GetCheck())
    g_ClientDevice.SetDigitalChannel(8);
  else
    g_ClientDevice.ClearDigitalChannel(8);
}

void CMainDlg::OnClickedSearchDevices()
{
  m_wndDevice0.SetCheck(0);
  m_wndDevice0.EnableWindow(FALSE);
  m_wndDevice1.SetCheck(0);
  m_wndDevice1.EnableWindow(FALSE);
  m_wndDevice2.SetCheck(0);
  m_wndDevice2.EnableWindow(FALSE);
  m_wndDevice3.SetCheck(0);
  m_wndDevice3.EnableWindow(FALSE);
  const int k = g_ClientDevice.SearchDevices();

  if (k > 0)
  {
    //Create Timer1
    if (m_nTimer1)
      KillTimer(m_nTimer1);
    m_nTimer1 = SetTimer(1, 50, nullptr);
  }

  bool bCardFound = false;
  if (k & 1)
  {
    bCardFound = true;
    m_wndDevice0.SetCheck(1);
    m_wndDevice0.EnableWindow(TRUE);
    OnBnClickedDevice0();
  }
  if (k & 2)
  {
    if (!bCardFound)
    {
      bCardFound = true;
      m_wndDevice1.SetCheck(1);
      m_wndDevice1.EnableWindow(TRUE);
      OnBnClickedDevice1();
    }
  }
  if (k & 4)
  {
    if (!bCardFound)
    {
      bCardFound = true;
      m_wndDevice2.SetCheck(1);
      m_wndDevice2.EnableWindow(TRUE);
      OnBnClickedDevice2();
    }
  }
  if (k & 8)
  {
    if (!bCardFound)
    {
      m_wndDevice3.SetCheck(1);
      m_wndDevice3.EnableWindow(TRUE);
      OnBnClickedDevice3();
    }
  }
}

void CMainDlg::OnBnClickedDevice0()
{
  if (g_ClientDevice.SetCurrentDevice(0) != -1)
    EnableControlsWhenDeviceIsOpen(TRUE);
}

void CMainDlg::OnBnClickedDevice1()
{
  if (g_ClientDevice.SetCurrentDevice(1) != -1)
    EnableControlsWhenDeviceIsOpen(TRUE);
}

void CMainDlg::OnBnClickedDevice2()
{
  if (g_ClientDevice.SetCurrentDevice(2) != -1)
    EnableControlsWhenDeviceIsOpen(TRUE);
}

void CMainDlg::OnBnClickedDevice3()
{
  if (g_ClientDevice.SetCurrentDevice(3) != -1)
    EnableControlsWhenDeviceIsOpen(TRUE);
}

void CMainDlg::OnClickedReadback()
{
  std::array<int, 2> analogOut{};
  g_ClientDevice.ReadBackAnalogOut(analogOut.data());
  const int nDigitalOut{ g_ClientDevice.ReadBackDigitalOut()};
  m_wndOutput1.SetCheck(nDigitalOut & 0x01);
  m_wndOutput2.SetCheck(nDigitalOut & 0x02);
  m_wndOutput3.SetCheck(nDigitalOut & 0x04);
  m_wndOutput4.SetCheck(nDigitalOut & 0x08);
  m_wndOutput5.SetCheck(nDigitalOut & 0x10);
  m_wndOutput6.SetCheck(nDigitalOut & 0x20);
  m_wndOutput7.SetCheck(nDigitalOut & 0x40);
  m_wndOutput8.SetCheck(nDigitalOut & 0x80);
#pragma warning(suppress: 26446)
  const int nAnalogValue1 = analogOut[0];
  m_wndDA1.SetPos(255 - nAnalogValue1);
  CString sValue;
  sValue.Format(_T("% 3d"), nAnalogValue1);
  m_wndDA1Value.SetWindowText(sValue);
#pragma warning(suppress: 26446)
  const int nAnalogValue2 = analogOut[1];
  m_wndDA2.SetPos(255 - nAnalogValue2);
  sValue.Format(_T("% 3d"), nAnalogValue2);
  m_wndDA2Value.SetWindowText(sValue);
  g_ClientDevice.OutputAnalogChannel(1, nAnalogValue1);
  g_ClientDevice.OutputAnalogChannel(2, nAnalogValue2);
}

void CMainDlg::OnClickedOutputTest()
{
  if (m_wndOutputTest.GetCheck())
  {
    //Create Timer2
    if (m_nTimer2)
      KillTimer(m_nTimer2);
    m_nTimer2 = SetTimer(2, 50, nullptr);

    m_wndOutputTest.SetWindowText(_T("Stop Output Test"));
  }
  else
  {
    //Kill Timer2
    KillTimer(m_nTimer2);
    m_nTimer2 = 0;

    g_ClientDevice.ClearAllDigital();
    m_wndOutput1.SetCheck(0);
    m_wndOutput2.SetCheck(0);
    m_wndOutput3.SetCheck(0);
    m_wndOutput4.SetCheck(0);
    m_wndOutput5.SetCheck(0);
    m_wndOutput6.SetCheck(0);
    m_wndOutput7.SetCheck(0);
    m_wndOutput8.SetCheck(0);

    m_wndOutputTest.SetWindowText(_T("Output Test"));
  }
}

void CMainDlg::EnableControlsWhenDeviceIsOpen(_In_ BOOL bOpen)
{
  m_wndAD1.EnableWindow(bOpen);
  m_wndAD2.EnableWindow(bOpen);
  m_wndDA1.EnableWindow(bOpen);
  m_wndDA2.EnableWindow(bOpen);
  m_wndOutput1.EnableWindow(bOpen);
  m_wndOutput2.EnableWindow(bOpen);
  m_wndOutput3.EnableWindow(bOpen);
  m_wndOutput4.EnableWindow(bOpen);
  m_wndOutput5.EnableWindow(bOpen);
  m_wndOutput6.EnableWindow(bOpen);
  m_wndOutput7.EnableWindow(bOpen);
  m_wndOutput8.EnableWindow(bOpen);
  m_wndInput1.EnableWindow(bOpen);
  m_wndInput2.EnableWindow(bOpen);
  m_wndInput3.EnableWindow(bOpen);
  m_wndInput4.EnableWindow(bOpen);
  m_wndInput5.EnableWindow(bOpen);
  m_wndReadback.EnableWindow(bOpen);
  m_wndOutputTest.EnableWindow(bOpen);
  m_wndResetCounter1.EnableWindow(bOpen);
  m_wndResetCounter2.EnableWindow(bOpen);
  m_wndCounter1Debounce1.EnableWindow(bOpen);
  m_wndCounter1Debounce2.EnableWindow(bOpen);
  m_wndCounter1Debounce3.EnableWindow(bOpen);
  m_wndCounter1Debounce4.EnableWindow(bOpen);
  m_wndCounter2Debounce1.EnableWindow(bOpen);
  m_wndCounter2Debounce2.EnableWindow(bOpen);
  m_wndCounter2Debounce3.EnableWindow(bOpen);
  m_wndCounter2Debounce4.EnableWindow(bOpen);
  m_wndConnect.EnableWindow(!bOpen);
  m_wndDisconnect.EnableWindow(bOpen);
  m_wndSetAllDigital.EnableWindow(bOpen);
  m_wndClearAllDigital.EnableWindow(bOpen);
  m_wndSetAllAnalog.EnableWindow(bOpen);
  m_wndClearAllAnalog.EnableWindow(bOpen);
  m_wndTestPWM.EnableWindow(bOpen);
  if (!bOpen)
  {
    m_wndDevice0.SetCheck(0);
    m_wndDevice1.SetCheck(0);
    m_wndDevice2.SetCheck(0);
    m_wndDevice3.SetCheck(0);
    m_wndDevice0.EnableWindow(bOpen);
    m_wndDevice1.EnableWindow(bOpen);
    m_wndDevice2.EnableWindow(bOpen);
    m_wndDevice3.EnableWindow(bOpen);
  }
}

void CMainDlg::OnClickedDisconnect()
{
  if (m_nTimer1)
  {
    KillTimer(m_nTimer1);
    m_nTimer1 = 0;
  }
  if (m_nTimer2)
  {
    KillTimer(m_nTimer2);
    m_nTimer2 = 0;
  }
  g_ClientDevice.CloseDevice();
  m_wndDA1.SetPos(255);
  m_wndDA2.SetPos(255);
  m_wndAD1.SetPos(0);
  m_wndAD2.SetPos(0);
  m_wndCounter1Value.SetWindowText(_T(""));
  m_wndCounter2Value.SetWindowText(_T(""));
  CString sValue;
  sValue.Format(_T("% 3d"), 0);
  m_wndAD1Value.SetWindowText(sValue);
  sValue.Format(_T("% 3d"), 0);
  m_wndAD2Value.SetWindowText(sValue);
  sValue.Format(_T("% 3d"), 0);
  m_wndDA1Value.SetWindowText(sValue);
  sValue.Format(_T("% 3d"), 0);
  m_wndDA2Value.SetWindowText(sValue);
  m_wndConnectResults.SetWindowText(_T("Disconnected"));
  EnableControlsWhenDeviceIsOpen(FALSE);
}

void CMainDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
  if ((pScrollBar != nullptr) && (pScrollBar->GetSafeHwnd() == m_wndDA1.GetSafeHwnd()))
  {
    const int nValue = 255 - m_wndDA1.GetPos();
    g_ClientDevice.OutputAnalogChannel(1, nValue);
    CString sValue;
    sValue.Format(_T("% 3d"), nValue);
    m_wndDA1Value.SetWindowText(sValue);
  }
  else if ((pScrollBar != nullptr) && (pScrollBar->GetSafeHwnd() == m_wndDA2.GetSafeHwnd()))
  {
    const int nValue = 255 - m_wndDA2.GetPos();
    g_ClientDevice.OutputAnalogChannel(2, nValue);
    CString sValue;
    sValue.Format(_T("% 3d"), nValue);
    m_wndDA2Value.SetWindowText(sValue);
  }
  else
    __super::OnVScroll(nSBCode, nPos, pScrollBar);
}

#pragma warning(suppress: 26440)
void CMainDlg::OnClickedTestPwm()
{
  const int nData = rand() % 255;
  g_ClientDevice.SetPWM(1, nData, 1);
  g_ClientDevice.SetPWM(2, nData, 2);
}
