//////////////////// Macros / Defines /////////////////////////////////////////

#ifndef __AFXWIN_H__
  #error include 'stdafx.h' before including this file for PCH
#endif //#ifndef __AFXWIN_H__


//////////////////// Includes /////////////////////////////////////////////////

#include "resource.h"


//////////////////// Classes //////////////////////////////////////////////////

class CDemoGUIApp : public CWinAppEx
{
public:
//Constructors / Destructors
  CDemoGUIApp();
  CDemoGUIApp(const CDemoGUIApp&) = delete;
  CDemoGUIApp(CDemoGUIApp&&) = delete;
  ~CDemoGUIApp() = default; //NOLINT(modernize-use-override)

//Methods
  CDemoGUIApp& operator=(const CDemoGUIApp&) = delete;
  CDemoGUIApp& operator=(CDemoGUIApp&&) = delete;

protected:
//Methods
  BOOL InitInstance() override;

  DECLARE_MESSAGE_MAP()
};

class CMainDlg : public CDialog
{
public:
//Constructors / Destructors
  CMainDlg();
  CMainDlg(const CMainDlg&) = delete;
  CMainDlg(CMainDlg&&) = delete;
  ~CMainDlg() = default; //NOLINT(modernize-use-override)

//Methods
  CMainDlg& operator=(const CMainDlg&) = delete;
  CMainDlg& operator=(CMainDlg&&) = delete;

//Member variables
  enum { IDD = IDD_MAIN };

protected:
//Member variables
  CSliderCtrl m_wndDA1;
  CStatic m_wndDA1Value;
  CSliderCtrl m_wndDA2;
  CStatic m_wndDA2Value;
  CProgressCtrl m_wndAD1;
  CStatic m_wndAD1Value;
  CProgressCtrl m_wndAD2;
  CStatic m_wndAD2Value;
  CStatic m_wndDLLVersionValue;
  CButton m_wndSK5;
  CButton m_wndSK6;
  CButton m_wndOutput1;
  CButton m_wndOutput2;
  CButton m_wndOutput3;
  CButton m_wndOutput4;
  CButton m_wndOutput5;
  CButton m_wndOutput6;
  CButton m_wndOutput7;
  CButton m_wndOutput8;
  CStatic m_wndConnectResults;
  CEdit m_wndCounter1Value;
  int m_nCounter1Value;
  CEdit m_wndCounter2Value;
  int m_nCounter2Value;
  CButton m_wndInput1;
  CButton m_wndInput2;
  CButton m_wndInput3;
  CButton m_wndInput4;
  CButton m_wndInput5;
  CButton m_wndDevice0;
  CButton m_wndDevice1;
  CButton m_wndDevice2;
  CButton m_wndDevice3;
  CButton m_wndOutputTest;
  CButton m_wndReadback;
  CButton m_wndResetCounter1;
  CButton m_wndResetCounter2;
  CButton m_wndCounter1Debounce1;
  CButton m_wndCounter1Debounce2;
  CButton m_wndCounter1Debounce3;
  CButton m_wndCounter1Debounce4;
  CButton m_wndCounter2Debounce1;
  CButton m_wndCounter2Debounce2;
  CButton m_wndCounter2Debounce3;
  CButton m_wndCounter2Debounce4;
  CButton m_wndDisconnect;
  CButton m_wndConnect;
  CButton m_wndSetAllDigital;
  CButton m_wndClearAllDigital;
  CButton m_wndSetAllAnalog;
  CButton m_wndClearAllAnalog;
  CButton m_wndTestPWM;
  int m_nCycleDigitalChannel;
  UINT_PTR m_nTimer1;
  UINT_PTR m_nTimer2;
  HICON m_hIcon;

//Methods
  void DoDataExchange(CDataExchange* pDX) override;
  BOOL OnInitDialog() override;
  void EnableControlsWhenDeviceIsOpen(_In_ BOOL bOpen);

//Message handlers
  afx_msg void OnClickedConnect();
  afx_msg void OnClickedDisconnect();
  afx_msg void OnClickedDllVersion();
  afx_msg void OnTimer(UINT_PTR nIDEvent);
  afx_msg void OnDestroy();
  afx_msg void OnClickedSetAllDigital();
  afx_msg void OnClickedSetAllAnalog();
  afx_msg void OnClickedClearAllAnalog();
  afx_msg void OnClickedClearAllDigital();
  afx_msg void OnClickedResetCounter1();
  afx_msg void OnClickedResetCounter2();
  afx_msg void OnBnClickedCounter1Debounce1();
  afx_msg void OnBnClickedCounter1Debounce2();
  afx_msg void OnBnClickedCounter1Debounce3();
  afx_msg void OnBnClickedCounter1Debounce4();
  afx_msg void OnBnClickedCounter2Debounce1();
  afx_msg void OnBnClickedCounter2Debounce2();
  afx_msg void OnBnClickedCounter2Debounce3();
  afx_msg void OnBnClickedCounter2Debounce4();
  afx_msg void OnBnClickedOutput1();
  afx_msg void OnBnClickedOutput2();
  afx_msg void OnBnClickedOutput3();
  afx_msg void OnBnClickedOutput4();
  afx_msg void OnBnClickedOutput5();
  afx_msg void OnBnClickedOutput6();
  afx_msg void OnBnClickedOutput7();
  afx_msg void OnBnClickedOutput8();
  afx_msg void OnClickedSearchDevices();
  afx_msg void OnBnClickedDevice0();
  afx_msg void OnBnClickedDevice1();
  afx_msg void OnBnClickedDevice2();
  afx_msg void OnBnClickedDevice3();
  afx_msg void OnClickedReadback();
  afx_msg void OnClickedOutputTest();
  afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

  DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnClickedTestPwm();
};


//Helper externs / functions
extern CDemoGUIApp theApp;
